# phd-repo-links

This repository acts as a pointer towards the various tools mentioned in my PhD
manuscript, or revolving around. While most of these tools are developped
mainly by me, I simply use some of the others here and did not even commit in
those repositories.

If any tool is missing from here, is missing a licence, etc., do not hesitate
to contact me :) My academic email address will probably have disappeared by
then, but you should have no trouble finding a valid one.

## PhD

* [PhD manuscript](https://git.tobast.fr/tobast/phd-thesis) (mirrored at gitlab
  inria)
* [PhD defense slides](https://git.tobast.fr/tobast/phd-defense) (mirrored at
  gitlab inria) CC BY-SA 4.0
* [PhD defense site](https://git.tobast.fr/tobast/phd-site) (GNU GPLv3)

## Backend

* [Palmed](https://gitlab.inria.fr/nderumig/palmed) (GPLv3)
* [Pipedream](https://gitlab.inria.fr/CORSE/pipedream) (GPLv3)
* [Palmed demo website](https://gitlab.inria.fr/CORSE/palmed-webdemo) (MIT),
  found [here](https://palmed.corse.inria.fr)

## Frontend

* [A72 frontend model](https://gitlab.inria.fr/tbastian/a72_frontend) (GPLv3)
* [Manual mapping tools](https://gitlab.inria.fr/tbastian/manual_arm_mapping) a
  set of scripts, bits of code and misc stuff, without any proper order to it,
  that helped me mapping manually.

## CesASMe -- evaluation of the SotA

You might need to explore the various branches of `CesASMe`'s repository to
find the small bits of code needed to evaluate other things that are not
mainline. It would do it good to refactor a bit the user interface, and its
interaction with the various measures made -- or not.

* [CesASMe](https://gitlab.inria.fr/CORSE/genbenchs) (GPLv3), somehow still
  partially called `genbenchs` as of today (but this is the tool!)
* [An old-ish version of its
  artifact](https://gitlab.inria.fr/CORSE/genbench-docker) (GPLv3)
* [gdb-bb-occur](https://gitlab.inria.fr/CORSE/gdb_bb_occur) (GPLv3), a simple
  instrumentation pass to obtain each basic block's occurrences across a run
* [tbastian-pyutils](https://gitlab.inria.fr/tbastian/pyutils.git) (GPLv3), a
  light Python library doing many things I wanted to factor out.
* [BHive testbench](https://gitlab.inria.fr/CORSE/bhive-testbench/) (MIT),
  simple modifications and scripts to assess BHive's accuracy.
* [PerfPipedream](https://gitlab.inria.fr/CORSE/perfpipedream) (GPLv3), used to
  expose Linux Perf events with a PAPI interface.

## Staticdeps

* [Staticdeps](https://gitlab.inria.fr/tbastian/staticdeps)
* [Depsim](https://gitlab.inria.fr/tbastian/valgrind-depsim), a fork of
  Valgrind featuring the `depsim` tool. This instrumentation pass extracts
  dependencies at runtime, to serve as a baseline. Lifetime of dependencies can
  be tweaked as a constant within the source code (and depsim must thus be
  recompiled to change this constant).
* [UiCA with staticdeps
  integrated](https://gitlab.inria.fr/CORSE/uica-staticdeps) (AGPLv3), a fork
  of UiCA integrating staticdeps.

## A72 combined

* [A72 combined](https://gitlab.inria.fr/CORSE/a72_combined) (GPLv3).
